# coding: utf-8

"""
    System Initiative API

    The API Server for interacting with a System Initiative workspace

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from system_initiative_api_client.models.connection_view_v1_one_of import ConnectionViewV1OneOf
from system_initiative_api_client.models.connection_view_v1_one_of1 import ConnectionViewV1OneOf1
from system_initiative_api_client.models.connection_view_v1_one_of2 import ConnectionViewV1OneOf2
from system_initiative_api_client.models.connection_view_v1_one_of3 import ConnectionViewV1OneOf3
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CONNECTIONVIEWV1_ONE_OF_SCHEMAS = ["ConnectionViewV1OneOf", "ConnectionViewV1OneOf1", "ConnectionViewV1OneOf2", "ConnectionViewV1OneOf3"]

class ConnectionViewV1(BaseModel):
    """
    ConnectionViewV1
    """
    # data type: ConnectionViewV1OneOf
    oneof_schema_1_validator: Optional[ConnectionViewV1OneOf] = None
    # data type: ConnectionViewV1OneOf1
    oneof_schema_2_validator: Optional[ConnectionViewV1OneOf1] = None
    # data type: ConnectionViewV1OneOf2
    oneof_schema_3_validator: Optional[ConnectionViewV1OneOf2] = None
    # data type: ConnectionViewV1OneOf3
    oneof_schema_4_validator: Optional[ConnectionViewV1OneOf3] = None
    actual_instance: Optional[Union[ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3]] = None
    one_of_schemas: Set[str] = { "ConnectionViewV1OneOf", "ConnectionViewV1OneOf1", "ConnectionViewV1OneOf2", "ConnectionViewV1OneOf3" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ConnectionViewV1.model_construct()
        error_messages = []
        match = 0
        # validate data type: ConnectionViewV1OneOf
        if not isinstance(v, ConnectionViewV1OneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectionViewV1OneOf`")
        else:
            match += 1
        # validate data type: ConnectionViewV1OneOf1
        if not isinstance(v, ConnectionViewV1OneOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectionViewV1OneOf1`")
        else:
            match += 1
        # validate data type: ConnectionViewV1OneOf2
        if not isinstance(v, ConnectionViewV1OneOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectionViewV1OneOf2`")
        else:
            match += 1
        # validate data type: ConnectionViewV1OneOf3
        if not isinstance(v, ConnectionViewV1OneOf3):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectionViewV1OneOf3`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ConnectionViewV1 with oneOf schemas: ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ConnectionViewV1 with oneOf schemas: ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ConnectionViewV1OneOf
        try:
            instance.actual_instance = ConnectionViewV1OneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConnectionViewV1OneOf1
        try:
            instance.actual_instance = ConnectionViewV1OneOf1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConnectionViewV1OneOf2
        try:
            instance.actual_instance = ConnectionViewV1OneOf2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConnectionViewV1OneOf3
        try:
            instance.actual_instance = ConnectionViewV1OneOf3.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ConnectionViewV1 with oneOf schemas: ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ConnectionViewV1 with oneOf schemas: ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ConnectionViewV1OneOf, ConnectionViewV1OneOf1, ConnectionViewV1OneOf2, ConnectionViewV1OneOf3]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


